#include "config_stc.h"

/////////////////////////// Using PWMA (16bit) ////////////////////////////////
void PWMA_Out_Init()
{
	/* 1、配置 PWM 输出引脚 */
	P1M0 |= 0x01; P1M1 &= ~0x01; // P1.0引脚 推挽输出

	PWMA_PS &= 0xFC;		// B 1111 1100 P1.0引脚

	/* 2、配置 PWMA 输出模式：在向上计数时，当PWMA_CNT<PWMA_CCR1时OC1REF输出高 */
	PWMA_CCER1 = 0x00;	// 设置 PWMA_CCMR1 之前须将 PWMA_CCER1 清零
	PWMA_CCMR1 &= 0x8F; // B 1000 1111 
	PWMA_CCMR1 |= 0x60; // B 0110 0000
	PWMA_CCER1 |= 0x01;	// B 0000 0001 使能 PWMA 比较输出
	
	/* 3、配置 PWM 的频率 = FOSC / ((PWMA_PSCR+1)*(PWMA_ARR+1)) = 200Hz */
	PWMA_PSCR = 0x0000;	// FOSC/(0+1) 默认走FOSC/1频率=12MHz
	PWMA_ARR = 0xEA60;	// D 60000 
	
	/* 4、配置 PWM 的占空比 */
	PWMA_CCR1 = (PWMA_ARR / 2);	// 默认50%占空比，在 PWMA_Out_Start(...) 中可由外部输入
	
	/* 5、配置输出链路 */
	PWMA_ENO |= 0x01;		// 使能PWM1P输出
	PWMA_BKR |= 0x80;		// 使能主输出
}

void PWMA_Out_UpdateDuty(uint16_t Duty);

void PWMA_Out_Start(uint16_t Duty)
{
	PWMA_Out_UpdateDuty(Duty);
	
	PWMA_CR1 |= 0x01;  // 使能 PWMA 计数器
}

void PWMA_Out_Stop()
{
	PWMA_CR1 &= ~0x01;  // 失能 PWMA 计数器
}

void PWMA_Out_UpdateDuty(uint16_t Duty)
{
	uint32_t tmp = PWMA_ARR;
	tmp = tmp * Duty;
	PWMA_CCR1 = tmp / 100;
}



