#include "config_stc.h"

/////////////////////////// Using Timer2 (24bit) ////////////////////////////////
void Timer2_Alarm_Init()
{
    AUXR &= 0xE3;	// B 1110 0011 FOSC的12分频 定时器模式
    TM2PS = 0x63;	// B 0000 1001 99+1=100分频, 计数频率降为10000Hz

    /* 
       200ms溢出中断一次
       T2H、T2L = 65536 - (200ms * FOSC)/((TM2PS + 1) * 12) 
                = 65536 - (0.2 * 12000000)/((99 + 1) * 12) = 65536 - 2000 = 63536 
                = 0xF830
       注：Timer2默认仅支持16位自动重装模式，用户无需在ISR中软件重装T2H和T2L
    */
	T2H = 0xF8;
    T2L = 0x30;

    IE2 |= 0x04;	// B 0000 0100 Timer2中断使能
    EA = 1;		    // B 1000 0000 EA=1 全局中断使能
}

void Timer2_Alarm_Start()
{
    AUXR |= 0x10;  // B 0001 0000 T2R = 1 使能 Timer2
}

void Timer2_Alarm_Stop()
{
    AUXR &= ~0x10;  // T2R = 0 失能 Timer2
}


